local f, loop, recent = CreateFrame('frame'), 0, {}
f:SetAllPoints()
f:SetAlpha(0)
f:SetFrameStrata('FULLSCREEN_DIALOG')

local tx = f:CreateTexture()
tx:SetBlendMode('ADD')
tx:SetAllPoints()
tx:SetTexture([[interface\fullscreentextures\lowhealth]])

local fade = f:CreateAnimationGroup()

local alpha = fade:CreateAnimation('Alpha')
alpha:SetChange(1)
alpha:SetDuration(0.5)
alpha:SetEndDelay(0.25)

fade:SetLooping('BOUNCE')
fade:SetScript('OnLoop', function()
	loop = loop + 1
	if loop >= 6 then
		alpha:SetChange(-1)
		fade:Finish()
	end
end)

local x1, x2, y1, y2 = GetObjectIconTextureCoords(41)
local MessageString = format('|Tinterface/minimap/objecticons.blp:16:16:0:0:256:256:%f:%f:%f:%f|t%%s detected at %%s!', x1 * 256, x2 * 256, y1 * 256, y2 * 256)

f:SetScript('OnEvent', function(_, event, id)
	local x, y, name, tipe = C_Vignettes.GetVignetteInfoFromInstanceID(id)
	if tipe == 41 or tipe == 42 or not tipe then
		local now = GetTime()
		if recent[id] and now - recent[id] < 30 then recent[id] = now return end -- ignore recently seen
		local msg = format(MessageString, name or 'Rare', date('%I:%M', time()))
		RaidWarningFrame_OnEvent(RaidWarningFrame, 'CHAT_MSG_RAID_WARNING', msg)
		DEFAULT_CHAT_FRAME:AddMessage(msg)
		recent[id] = now
		PlaySoundFile([[sound\event sounds\event_wardrum_ogre.wav]], 'Master')
		PlaySoundFile([[sound\events\scourge_horn.wav]], 'Master')
		loop = 0
		alpha:SetChange(1)
		fade:Play()
	end
end)
f:RegisterEvent('VIGNETTE_ADDED')